


       integer function ivcleof(y,x)
c
c    This routine clears to the end of the screen, beginning with the
c    position row=y, column=x. The cursor is then placed at (y,x)
c
       include 'Pstuff.com'
       character blank*79
       integer y,x,ypos,xpos

c AMcW 8/2003
	return
cc
c 
c       write(blank,1001)
c1001   format(79(' '))
c       istat = ivwrite(y,x,blank,79)
c       xpos = 1
c       ypos = y
c
c
c       do 11 ipos=ypos,maxline
c          istat = ivmove(ipos,xpos)
c11        istat = ivcleol()
c       istat = ivmove(y,x)
cc
c       ivcleof = 0
c       return
       end





       integer function ivwrite(y,x,arr,ccount)
c
c    This routine writes out a string of characters from 'arr',
c    with the first character beginning at row=y, column=x. The length
c    of the string may be at most 79 characters, and this routine
c    will not write on the 80th column or the 25th row of the screen.
c
       include 'Pstuff.com'
       integer y,x,count,ccount
       character arr*80,dummy*80,string(80)*1,esc*1
       equivalence (dummy,string(1))
c
c AMcW 8/2003
	return
cc
c       count = ccount
c       if (y .gt. maxline .or. x .gt. 79) then
c          ivwrite = -1
c          return
c       endif
cc
c       esc = char(27)
c       dummy = arr
c       count = min0(80-x,count)
cc       
c       if (x .lt. 10) then
c          if (y .lt. 10) then
c             write (*,1007) esc,y,x,(string(i),i=1,count)
c1007         format(1x,a1,'[',i1,';',i1,'H',80a1)
c          else
c             write (*,1006) esc,y,x,(string(i),i=1,count)
c1006         format(1x,a1,'[',i2,';',i1,'H',80a1)
c          endif
cc       else 
c          if (y .lt. 10) then
c             write (*,1005) esc,y,x,(string(i),i=1,count)
c1005         format(1x,a1,'[',i1,';',i2,'H',80a1)
c          else
c             write (*,1004) esc,y,x,(string(i),i=1,count)
c1004         format(1x,a1,'[',i2,';',i2,'H',80a1)
c          endif
c       endif
cc
c       ivwrite = 0
c       return
       end






       integer function ivmove(y,x)
c
c    This routine moves the cursor to position row=y, column=x.
c    It checks to be sure that y does not exceed 'maxline', and x does not
c    exceed 79 (the screen limits).
c
       include 'Pstuff.com'
       integer y,x
       character esc*1
c
c AMcW 8/2003
	return
c
c       if (y .gt. maxline .or. x .gt. 79) then
c          ivmove = -1
c          return
c       endif
cc
c       esc = char(27)
cc       
c       if (x .lt. 10) then
c          if (y .lt. 10) then
c             write (*,1007) esc,y,x
c1007         format(1x,a1,'[',i1,';',i1,'H')
c          else
c             write (*,1006) esc,y,x
c1006         format(1x,a1,'[',i2,';',i1,'H')
c          endif
c       else 
c          if (y .lt. 10) then
c             write (*,1005) esc,y,x
c1005         format(1x,a1,'[',i1,';',i2,'H')
c          else
c             write (*,1004) esc,y,x
c1004         format(1x,a1,'[',i2,';',i2,'H')
c          endif
c       endif
cc
c       ivmove = 0
c       return
       end



    


       integer function ivcleol()
c    This routine clears to the end of a line, beginning with the current
c    cursor position.
c
       character*1 esc
c
c AMcW 8/2003
	return
c
c       esc = char(27)
c       write(*,1001) esc
c1001   format(1x,a1,'[K')
cc
c       ivcleol = 0
c       return
       end




       integer function ivbold(on)
c    
c    This routine either turns on the bold-face lettering, if on=1,
c    or turns it off, if on=0
c
       integer on
       character*1 esc
c
c AMcW 8/2003
	return
c
c       esc = char(27)
c       if(on.eq.1) then
c             write(*,'(1x,a1,a)') esc,'[1m'
c       else
c             write(*,'(1x,a1,a)') esc,'[0m'
c       endif 
cc
c       ivbold = 0
c       return
       end





       integer function ivundl(on)
c
c    This routine either turns on the underlining of text, if on=1,
c    or turns it off.
c
       integer on
       character*1 esc
c
c AMcW 8/2003
	return
c
c       esc = char(27)
c       if(on.eq.1) then
c             write(*,'(1x,a1,a)') esc,'[4m'
c       else
c             write(*,'(1x,a1,a)') esc,'[0m'
c       endif 
cc
c       ivundl = 0
c       return
       end

 




       integer function ivcpos(x,y)
c
c    Damned if I know what this clever little routine does!
c
       integer x,y
       character*1 esc

c AMcW 8/2003
	return
c
c       esc = char(27)
c       write(*,'(1x,a1,a)') esc,'[6n'
c
c       ivcpos = 0
c       return
       end


