      subroutine begin
c***************************************************************************
c     This routine simply starts up MOOG
c***************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Chars.com'
      include 'Atmos.com'
      include 'Pstuff.com'
      include 'Linex.com'

c  clear the text screen, and define the number of lines available 
c  on the screen
c     call screenlength (maxline)
      maxline = 30
      if (maxline .lt. 10) then
         maxline = 24
      else
         maxline = maxline - 2
      endif
c     call system('clear')

c  initialize some variables
      filemodel = 0
      filelines = 0
      fileslines = 0
      fileobs = 0
      nwrite = 0
      n2write = 0
      ndump = 0
      n2dump = 0
      nparam = 0

c  write a header and find the appropriate parameter file
      write (array,1001)
1001  format (79('*'))
c     istat = ivwrite (1,1,array,79)
      write (array,1004)
1004  format (29(' '),'MOOG (March 12, 1997)',29(' '))
c     istat = ivwrite (2,1,array,79)
c     array = 'WHAT IS YOUR PARAMETER FILE? ' 
c     nchars = 29
      nparam = 50     
c     call infile ('input  ',nparam,'formatted  ',0,nchars,3)

c AMcW. 12/Aug/2003
      open(unit=nparam,file='ilabunds.par',status='old')

c Initializations for subroutine moog  AMcW  12/Aug/2003
      firsttime = .true.
      wavestep = 0.0
      do i = 1,75
         vturb(i) = 0.0
      enddo
c

      read (nparam,1002) control
1002  format (a7)
      write (array,1003) control
1003  format (22x,'MOOG IS CONTROLLED BY DRIVER ',a7)
c     istat = ivwrite (2,1,array,58)
      write (array,1001)
c     istat = ivwrite (3,1,array,79)

      return
      end
      

